Yate: DataFormat Class Reference

Yate

Public Member Functions | Protected Member Functions | List of all members
DataFormat Class Reference

A Data format. More...

`#include <yatephone.h>`

Inheritance diagram for DataFormat:

## Public Member Functions
| DataFormat ()
| DataFormat (const char *value)
| DataFormat (const DataFormat &value)
| DataFormat (const String &value)
| DataFormat (const NamedList &value)
| DataFormat (const String *value)
| DataFormat (const FormatInfo *format)
DataFormat & | operator= (const DataFormat &value)
const FormatInfo * | getInfo () const
int | frameSize (int defValue=0) const
int | frameTime (int defValue=0) const
int | sampleRate (int defValue=0) const
int | numChannels (int defValue=1) const
Public Member Functions inherited from NamedList
| NamedList (const char *name)
| NamedList (const NamedList &original)
| NamedList (const char *name, const NamedList &original, const String &prefix)
NamedList & | operator= (const NamedList &value)
virtual void * | getObject (const String &name) const
unsigned int | length () const
unsigned int | count () const
void | clearParams ()
NamedList & | addParam (NamedString *param)
NamedList & | addParam (const char *name, const char *value, bool emptyOK=true)
NamedList & | addParam (const char *name, int64_t value)
NamedList & | addParam (const char *name, uint64_t value)
NamedList & | addParam (const char *name, int32_t value)
NamedList & | addParam (const char *name, uint32_t value)
NamedList & | addParam (const char *name, double value)
NamedList & | addParam (const char *name, bool value)
NamedList & | addParam (const char *name, unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
NamedList & | addParam (const char *name, uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
NamedList & | addParamHex (const char *name, const void *buf, unsigned int len, char sep=0)
NamedList & | setParam (NamedString *param)
NamedList & | setParam (const String &name, const char *value)
NamedList & | setParam (const String &name, int64_t value)
NamedList & | setParam (const String &name, uint64_t value)
NamedList & | setParam (const String &name, int32_t value)
NamedList & | setParam (const String &name, uint32_t value)
NamedList & | setParam (const String &name, double value)
NamedList & | setParam (const String &name, bool value)
NamedList & | setParam (const String &name, unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
NamedList & | setParam (const String &name, uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
NamedList & | setParamHex (const String &name, const void *buf, unsigned int len, char sep=0)
NamedList & | clearParam (const String &name, char childSep=0, const String *value=0)
NamedList & | clearParam (NamedString *param, bool delParam=true)
NamedList & | copyParam (const NamedList &original, const String &name, char childSep=0)
NamedList & | copyParams (bool replace, const NamedList &original, bool copyUserData=false)
NamedList & | copyParams (const NamedList &original)
NamedList & | copyParams (const NamedList &original, ObjList *list, char childSep=0)
NamedList & | copyParams (const NamedList &original, const String &list, char childSep=0)
NamedList & | copySubParams (const NamedList &original, const String &prefix, bool skipPrefix=true, bool replace=false)
bool | hasSubParams (const char *prefix) const
int | getIndex (const NamedString *param) const
int | getIndex (const String &name) const
NamedString * | getParam (const String &name) const
NamedString * | getParam (unsigned int index) const
const String & | operator[] (const String &name) const
const char * | getValue (const String &name, const char *defvalue=0) const
int | getIntValue (const String &name, int defvalue=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | getIntValue (const String &name, const TokenDict *tokens, int defvalue=0) const
int | getIntValue (const String &name, const TokenDictStr *tokens, int defvalue=0) const
int64_t | getInt64Value (const String &name, int64_t defvalue=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
int64_t | getInt64ValueDict (const String &name, const TokenDict64 *tokens, int64_t defvalue=0) const
int64_t | getInt64ValueDict (const String &name, const TokenDictStr64 *tokens, int64_t defvalue=0) const
uint64_t | getUInt64Value (const String &name, uint64_t defvalue=0, uint64_t minvalue=0, uint64_t maxvalue=ULLONG_MAX, bool clamp=true) const
double | getDoubleValue (const String &name, double defvalue=0.0) const
bool | getBoolValue (const String &name, bool defvalue=false) const
int | replaceParams (String &str, bool sqlEsc=false, char extraEsc=0) const
void | dump (String &str, const char *separator, char quote=0, bool force=false) const
bool | dump (String &str, unsigned int flags, const char *separator, const char *nameSep=0, const char *prefix=0, char quote=0) const
ObjList * | paramList ()
const ObjList * | paramList () const
Public Member Functions inherited from String
| String ()
| String (const char *value, int len=-1)
| String (char value, unsigned int repeat=1)
| String (int32_t value)
| String (uint32_t value)
| String (int64_t value)
| String (uint64_t value)
| String (bool value)
| String (double value)
| String (const String &value)
| String (const String *value)
virtual | ~String ()
const char * | c_str () const
const char * | safe () const
const char * | safe (const char *defStr) const
unsigned int | length () const
bool | null () const
int | lenUtf8 (uint32_t maxChar=0x10ffff, bool overlong=false) const
int | fixUtf8 (const char *replace=0, uint32_t maxChar=0x10ffff, bool overlong=false)
unsigned int | encodeFlags (const TokenDict *tokens) const
uint64_t | encodeFlags (const TokenDict64 *tokens) const
String & | decodeFlags (unsigned int flags, const TokenDict *tokens, bool unknownflag=true)
String & | decodeFlags (uint64_t flags, const TokenDict64 *tokens, bool unknownflag=true)
bool | checkBOM () const
bool | stripBOM ()
unsigned int | hash () const
void | clear ()
char | at (int index) const
String | substr (int offs, int len=-1) const
String & | trimBlanks ()
String & | trimSpaces ()
virtual const String & | toString () const
int | toInteger (int defvalue=0, int base=0, int minvalue=INT_MIN, int maxvalue=INT_MAX, bool clamp=true) const
int | toInteger (const TokenDict *tokens, int defvalue=0, int base=0) const
int | toInteger (const TokenDictStr *tokens, int defvalue=0, int base=0) const
long int | toLong (long int defvalue=0, int base=0, long int minvalue=LONG_MIN, long int maxvalue=LONG_MAX, bool clamp=true) const
int64_t | toInt64 (int64_t defvalue=0, int base=0, int64_t minvalue=LLONG_MIN, int64_t maxvalue=LLONG_MAX, bool clamp=true) const
int64_t | toInt64Dict (const TokenDict64 *tokens, int64_t defvalue=0, int base=0) const
int64_t | toInt64Dict (const TokenDictStr64 *tokens, int64_t defvalue=0, int base=0) const
uint64_t | toUInt64 (uint64_t defvalue=0, int base=0, uint64_t minvalue=0, uint64_t maxvalue=ULLONG_MAX, bool clamp=true) const
double | toDouble (double defvalue=0.0) const
bool | toBoolean (bool defvalue=false) const
bool | isBoolean () const
String & | toUpper ()
String & | toLower ()
char | operator[] (signed int index) const
char | operator[] (unsigned int index) const
| operator const char * () const
String & | assign (const char *value, int len=-1)
String & | assign (char value, unsigned int repeat=1)
String & | hexify (const void *data, unsigned int len, char sep=0, bool upCase=false)
String & | operator= (const String &value)
String & | operator= (const String *value)
String & | operator= (const char *value)
String & | operator= (char value)
String & | operator= (int32_t value)
String & | operator= (uint32_t value)
String & | operator= (int64_t value)
String & | operator= (uint64_t value)
String & | operator= (bool value)
String & | operator= (double value)
String & | operator+= (const char *value)
String & | operator+= (char value)
String & | operator+= (int32_t value)
String & | operator+= (uint32_t value)
String & | operator+= (int64_t value)
String & | operator+= (uint64_t value)
String & | operator+= (bool value)
String & | operator+= (double value)
bool | operator== (const char *value) const
bool | operator!= (const char *value) const
bool | operator== (const String &value) const
bool | operator!= (const String &value) const
bool | operator&= (const char *value) const
bool | operator|= (const char *value) const
String & | operator<< (const char *value)
String & | operator<< (char value)
String & | operator<< (int32_t value)
String & | operator<< (uint32_t value)
String & | operator<< (int64_t value)
String & | operator<< (uint64_t value)
String & | operator<< (bool value)
String & | operator<< (double value)
String & | operator>> (const char *skip)
String & | operator>> (char &store)
String & | operator>> (UChar &store)
String & | operator>> (int &store)
String & | operator>> (unsigned int &store)
String & | operator>> (bool &store)
String & | append (const char *value, int len)
String & | append (const char *value, const char *separator=0, bool force=false)
String & | append (const ObjList *list, const char *separator=0, bool force=false)
String & | append (const ObjList &list, const char *separator=0, bool force=false)
String & | append (char value, unsigned int len=1)
String & | append (double value, unsigned int decimals=3)
String & | insert (unsigned int pos, const char *value, int len=-1)
String & | insert (unsigned int pos, char value, unsigned int len=1)
String & | printf (const char *format,...)
String & | printf (unsigned int length, const char *format,...)
String & | printfAppend (const char *format,...)
String & | printfAppend (unsigned int length, const char *format,...)
String & | appendFixed (unsigned int fixedLength, const char *str, unsigned int len=-1, char fill=' ', int align=Left)
String & | appendFixed (unsigned int fixedLength, const String &str, char fill=' ', int align=Left)
int | find (char what, unsigned int offs=0) const
int | find (const char *what, unsigned int offs=0) const
int | rfind (char what) const
int | rfind (const char *what) const
bool | startsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | endsWith (const char *what, bool wordBreak=false, bool caseInsensitive=false) const
bool | startSkip (const char *what, bool wordBreak=true, bool caseInsensitive=false)
String & | replaceChars (const char *what, const char *repl, bool inPlace=false, int wLen=-1, int rLen=-1, bool *chg=0)
String & | removeChars (const char *what, int wLen=-1, bool *chg=0)
String & | extractTo (const char *sep, String &store)
String & | extractTo (const char *sep, bool &store)
String & | extractTo (const char *sep, int &store, int base=0)
String & | extractTo (const char *sep, int &store, const TokenDict *tokens, int base=0)
String & | extractTo (const char *sep, double &store)
virtual bool | matches (const String &value) const
bool | matches (const Regexp &rexp)
int | matchOffset (int index=0) const
int | matchLength (int index=0) const
String | matchString (int index=0) const
String | replaceMatches (const String &templ) const
int | matchCount () const
ObjList * | split (ObjList &list, char separator, bool emptyOK=true) const
ObjList * | split (ObjList &list, const Regexp &reg, bool emptyOK=true) const
ObjList * | split (char separator, bool emptyOK=true) const
ObjList * | split (const Regexp &reg, bool emptyOK=true) const
String | msgEscape (char extraEsc=0) const
String | msgUnescape (int *errptr=0, char extraEsc=0) const
String | sqlEscape (char extraEsc=0) const
String & | uriEscapeTo (String &buf, char extraEsc=0, const char *noEsc=0) const
String | uriEscape (char extraEsc=0, const char *noEsc=0) const
String & | uriUnescapeTo (String &buf, bool setPartial=false, int *errptr=0) const
String & | uriUnescapeStr (bool setPartial=false, int *errptr=0)
String | uriUnescape (int *errptr=0, bool setPartial=true) const
Public Member Functions inherited from GenObject
| GenObject ()
virtual | ~GenObject ()
virtual bool | alive () const
virtual void | destruct ()
virtual const String & | traceId () const
NamedCounter * | getObjCounter () const
NamedCounter * | setObjCounter (NamedCounter *counter)

## Protected Member Functions
virtual void | changed ()

## Additional Inherited Members
Public Types inherited from NamedList
enum | DumpFlags { DumpAddSeparator = 0x0001 , DumpForcePrefix = 0x0001 , DumpName = 0x0002 , DumpQuoteName = 0x0004 , DumpEmptyName = 0x0008 , DumpQuoteParamName = 0x0010 , DumpDontQuoteParamValue = 0x0020 }
Public Types inherited from String
enum | Align { Left = 0 , Center , Right }
Static Public Member Functions inherited from NamedList
static const NamedList & | empty ()
Static Public Member Functions inherited from String
static const String & | empty ()
static const char * | boolText (bool value)
static int | lenUtf8 (const char *value, uint32_t maxChar=0x10ffff, bool overlong=false)
static bool | checkBOM (const char *str)
static bool | stripBOM (const char *&str)
static bool | stripBOM (char *&str)
static unsigned int | hash (const char *value, unsigned int h=0)
static String | msgEscape (const char *str, char extraEsc=0)
static String | msgUnescape (const char *str, int *errptr=0, char extraEsc=0)
static String | sqlEscape (const char *str, char extraEsc=0)
static String & | uriEscapeTo (String &buf, const char *str, char extraEsc=0, const char *noEsc=0)
static String & | uriEscapeTo (String &buf, const char *str, const char *extraEsc, const char *noEsc=0)
static String | uriEscape (const char *str, char extraEsc=0, const char *noEsc=0)
static String | uriEscape (const char *str, const char *extraEsc, const char *noEsc=0)
static String & | uriUnescapeTo (String &buf, const char *str, bool setPartial=false, int *errptr=0)
static String | uriUnescape (const char *str, int *errptr=0, bool setPartial=true)
static const String * | atom (const String *&str, const char *val)
static unsigned int | c_starts_with (const char *str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_ends_with (const char *str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_skip (const char *&str, const char *what, int lenStr=-1, int lenWhat=-1, bool caseInsensitive=false)
static unsigned int | c_skip_chars (const char *&str, const char *what, int len=-1, bool skipFound=true)
static char * | c_replace_chars (const char *str, const char *what, const char *repl=0, bool inPlace=false, int wLen=-1, int rLen=-1, bool *chg=0)
Static Public Member Functions inherited from GenObject
static void * | getObject (const String &name, const GenObject *obj)
static bool | getObjCounting ()
static void | setObjCounting (bool enable)
static NamedCounter * | getObjCounter (const String &name, bool create=true)
static ObjList & | getObjCounters ()

## Detailed Description

A Data format.

An extension of a String that can parse data formats

## Constructor & Destructor Documentation

## ◆ DataFormat() [1/7]

DataFormat | ( |  | ) |
| inline

Creates a new, empty format string.

References NamedList::NamedList().

Referenced by DataFormat(), and operator=().

## ◆ DataFormat() [2/7]

DataFormat | ( | const char * | value | ) |
| inline

Creates a new initialized format.

Parameters

  value | Initial value of the format

References NamedList::NamedList().

## ◆ DataFormat() [3/7]

DataFormat | ( | const DataFormat & | value | ) |
| inline

Copy constructor.

Parameters

  value | Initial value of the format

References DataFormat(), getInfo(), and NamedList::NamedList().

## ◆ DataFormat() [4/7]

DataFormat | ( | const String & | value | ) |
| inline

Constructor from String reference

Parameters

  value | Initial value of the format

References NamedList::NamedList(), and String::String().

## ◆ DataFormat() [5/7]

DataFormat | ( | const NamedList & | value | ) |
| inline

Constructor from NamedList reference

Parameters

  value | Initial value of the format and parameters

References NamedList::NamedList().

## ◆ DataFormat() [6/7]

DataFormat | ( | const String * | value | ) |
| inline

Constructor from String pointer.

Parameters

  value | Initial value of the format

References String::c_str(), NamedList::NamedList(), and String::String().

## ◆ DataFormat() [7/7]

DataFormat | ( | const FormatInfo * | format | ) |
| inlineexplicit

Constructor from format information

Parameters

  format | Pointer to existing FormatInfo

References NamedList::NamedList().

## Member Function Documentation

## ◆ changed()

virtual void changed | ( |  | ) |
| protectedvirtual

Called whenever the value changed (except in constructors).

Reimplemented from String.

## ◆ frameSize()

int frameSize | ( | int | defValue = 0 | ) | const
| inline

Retrieve the frame size

Parameters

  defValue | Default value to return if format is unknown

Returns
  Frame size in octets/frame, 0 for non-framed, defValue if unknown

References FormatInfo::frameSize, and getInfo().

## ◆ frameTime()

int frameTime | ( | int | defValue = 0 | ) | const
| inline

Retrieve the frame time

Parameters

  defValue | Default value to return if format is unknown

Returns
  Frame time in microseconds, 0 for variable, defValue if unknown

References FormatInfo::frameTime, and getInfo().

## ◆ getInfo()

const FormatInfo * getInfo | ( |  | ) | const

Retrieve a pointer to the format information

Returns
  Pointer to the associated format info or NULL if error

Referenced by DataFormat(), frameSize(), frameTime(), numChannels(), operator=(), and sampleRate().

## ◆ numChannels()

int numChannels | ( | int | defValue = 1 | ) | const
| inline

Retrieve the number of channels

Parameters

  defValue | Default value to return if format is unknown

Returns
  Number of channels (typically 1), defValue if unknown format

References getInfo(), and FormatInfo::numChannels.

## ◆ operator=()

DataFormat & operator= | ( | const DataFormat & | value | ) |
| inline

Assignment operator.

References DataFormat(), getInfo(), and NamedList::operator=().

## ◆ sampleRate()

int sampleRate | ( | int | defValue = 0 | ) | const
| inline

Retrieve the sample rate

Parameters

  defValue | Default value to return if format is unknown

Returns
  Rate in samples/second (audio) or 1e-6 frames/second (video), 0 for unknown, defValue if unknown format

References getInfo(), and FormatInfo::sampleRate.

The documentation for this class was generated from the following file:

- yatephone.h